## numba 0.56.4+dfsg

=== debian/changelog ===
numba (0.56.4+dfsg-2) unstable; urgency=medium

  [ Diane Trout ]
  * Backport patches from https://github.com/numba/numba/pull/8590 into
    patches/python3.11/
    0054-Apply-suggestions-from-code-review.patch
    0055-Fix-arrayexprs-for-py3.11.patch
    0056-Fix-LOAD_GLOBAL-arg-use-in-test_parfors-for-py3.11.patch
    0057-Move-_fix_LOAD_GLOBAL-arg-to-bytecode-module-and-use-it-in-_compute_used_globals.patch
    0058-Fix-text_flow_control-for-py3.11.patch
    0059-Not-a-py311-change-stop-printing-source-code.patch
    0060-Attempt-to-fix-cellvars.patch
    0061-Fix-CodeType-usage.patch
    0062-Remove-duplicated-handling-of-CodeType.patch
    0063-Flake8-fixes.patch
    0064-More-flake8-fixes.patch
    0065-Enable-list_to_tuple-peephole-for-py3.11.patch
    0067-Update-numba-core-byteflow.py.patch
    0068-Get-rid-of-custom-copy_code_type.-Use-CodeType.Replace-instead.patch
  * Add Origin header for the 8545 pull request for the earlier patches
  * Backport patches from https://github.com/numba/numba/pull/8639
      201-Update-string-bytes-hash-algs-to-siphash13-for-Python.patch
      202-Fix-flake8.patch
      203-Attempt-to-fix-closures.patch
      204-Enable-more-peephole-rewrites-in-3.11.patch
      205-Fix-test_dump_bytecode.patch
      206-Fix-f-string-const-name-interp.patch
      207-Rewrite-_jump_if_none-to-match-pre-py3.11.patch
      208-Fix-near-and-far-jump-target-ordering.patch
      209-Add-more-new-op-code-handling.patch
      210-Fix-issue-with-EXTENDED_ARG-test-and-update-test.patch
      211-Add-pop-NULL-to-CALL_FUNCTION_EX-byteflow-analysis.patch
      212-Fix-out-of-bounds-loop-index-in-test.patch
      213-Accommodate-multiple-bytecodes-at-block-start-with-no.patch
      214-Fix-parfors-prange-test-generator-LOAD_GLOBAL-args.patch
      215-Update-assertion-for-Python-3.11-style-error-messages.patch
      216-Fix-bytecode-iteration-to-handle-EXTENDED_ARG-as-jump.patch
      217-Fix-rebase-error-in-op_LOAD_DEREF.patch
      218-Respond-to-feedback-RE-use-of-_is_null_temp_reg-in.patch
      219-Fix-binop-names-to-be-legal-variable-names.patch
      220-Update-test_extended_arg-to-use-CodeType.replace.patch
  * Backport pull request https://github.com/numba/numba/pull/8644
      301-Fix-bare-reraise-support.patch
  * Try to implement nocheck test skipping
  * Mark known problmatic tests with expectedFailure("python3.11")
    tests-failing-python3.patch

 -- Diane Trout <diane@ghic.org>  Sun, 05 Feb 2023 20:51:25 -0800

numba (0.56.4+dfsg-1) unstable; urgency=medium

  * Warning! The upstream patches added to support Python 3.11 are
    incomplete at present and there are test failures with Numba
    running with Python 3.11.
  * New upstream release
  * Increment Build-Depends as 0.56.4 supports up to numpy 1.24
    (Closes: #1026286)
  * Backport https://github.com/numba/numba/pull/8545 to support
    Python 3.11 (Closes: #1024031)
  * Add lintian override about np/ufunc/_num_threads library as it is
    not linked to libc in Python 3.11 either.
  * Bump Standards-Version to 4.6.1. No changes needed.
  * Use numbas runtests.py instead of pytest for running build time tests.
    - upstreams test runner is parallelized.
    - also I limited the test runner to choose a random 20% of the tests
      as builds frequently exceeded builder runtime limits.
    - add pybuild.testfiles to copy runtests driver into build directory.
  * Remove pytest packages from Build-Dependencies since they're unused now.
  * Override litian error for very-long-line in numba/tests/test_nrt.py
    The long line is the symbolic representation of what the test
    generated assembly code should be.
  * Add numpy-1-24-pr8691.patch with some small modifications to build with
    the Python 3.11 patches and adjust the maximum numpy version.
    (Closes: #1026286)
    This allows increasing numpy build depends to << 1.25

 -- Diane Trout <diane@ghic.org>  Sat, 07 Jan 2023 21:21:26 -0800

numba (0.56.2+dfsg-3) unstable; urgency=medium

  * Skip long running tests during build.
    Will Hopefully allow builds to finish on slower architectures.
  * Disable onetbb as Debian's version is too new for Numba
  * Limit autopkgtest threading to no more than 16 on PPC.
  * add-test-tags to skip tests some tests, especially ones that
    require finding the pyc files
  * Skip some gdb test cases if numba optimization isn't set to 0
  * more closely match upstreams test environment for autopkgtests

 -- Diane Trout <diane@ghic.org>  Thu, 06 Oct 2022 09:07:55 -0700

numba (0.56.2+dfsg-2) unstable; urgency=medium

  * Update llvmlite build-dependency (Closes: #1019945)
  * Add use-python3-test-nonsense-gdb-binary.patch (Closes: #1019949)
  * add reorder-setuptools-import.patch to build with setuptools 65

 -- Diane Trout <diane@ghic.org>  Sun, 18 Sep 2022 16:00:37 -0700

numba (0.56.2+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1018786)
  * Refresh patches
  * Ignore lintian error about _num_threads extentsion not using C
    symbols.

 -- Diane Trout <diane@ghic.org>  Wed, 07 Sep 2022 13:06:48 -0700

=== debian/control ===
Source: numba
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Diane Trout <diane@ghic.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all-dev,
               python3-colorama (>= 0.3.9~),
               python3-llvmlite (>= 0.39~),
               python3-numpy (<< 1:1.25),
               python3-pip,
               sphinx,
               dh-sequence-sphinxdoc,
               python3-scipy,
               python3-sphinx-rtd-theme,
               python3-setuptools,
               python3-numpydoc,
               libtbb-dev (>= 2021.4.0)
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/numba
Vcs-Git: https://salsa.debian.org/science-team/numba.git
Homepage: https://numba.pydata.org/
Rules-Requires-Root: no

Package: python3-numba
Architecture: any
Section: python
Depends: python3-llvmlite,
         python3-scipy,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: numba-doc,
            python3-pip
Suggests: nvidia-cuda-toolkit [amd64 ppc64el]
Description: native machine code compiler for Python 3
 Numba compiles native machine code instructions from Python programs at
 runtime using the LLVM compiler infrastructure. It could be easily employed
 by decorating individual computation intensive functions in the Python code.
 Numba could significantly speed up the performance of computations, and
 optionally supports compilation to run on GPU processors through Nvidia's
 CUDA platform.
 It integrates well with the Python scientific software stack, and
 especially recognizes Numpy arrays.
 .
 This package contains the modules for Python 3.

Package: numba-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: python3-numba
Description: native machine code compiler for Python (docs)
 Numba compiles native machine code instructions from Python programs at
 runtime using the LLVM compiler infrastructure. Just-in-time compilation with
 Numba could be easily employed by decorating individual computation intensive
 functions in the Python code.
 Numba could significantly speed up the performance of computations, and
 optionally supports compilation to run on GPU processors through Nvidia's
 CUDA platform.
 It integrates well with the Python scientific software stack, and
 especially recognizes Numpy arrays.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS=nocheck
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME            = numba
export PYBUILD_INSTALL_ARGS    = --install-scripts=/usr/share/{package}

# Disable TBB as Numba only supports up 2022.05.
# https://github.com/numba/numba/issues/8487
export NUMBA_DISABLE_TBB=1

SPHINX_BUILD = $(shell py3versions -d) /usr/bin/sphinx-build
PYBUILD_DEFAULT_VERSION = $(shell py3versions -v -d)

PYBUILD_DIR = $(shell pybuild --print {build_dir} | grep $(PYBUILD_DEFAULT_VERSION) )

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test-indep:
	echo "Tests are performed for arch builds only".

override_dh_auto_test-arch:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
	PYBUILD_TEST_ARGS="ls {build_dir} && cd {build_dir} && MPLBACKEND=Agg {interpreter} -Wd runtests.py --exclude-tags='long-running,gdb,compiled_caching' -v -m --random 0.2 -- numba.tests"  dh_auto_test || true
endif

override_dh_installchangelogs:
	dh_installchangelogs -A CHANGE_LOG

override_dh_installdocs:
	dh_installdocs -A README.rst
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	cp -a docs CHANGE_LOG $(PYBUILD_DIR)
	http_proxy='127.0.0.1:9' PYTHONPATH=$(PYBUILD_DIR):$${PYTHONPATH} $(SPHINX_BUILD) -N -bhtml \
			   $(PYBUILD_DIR)/docs/source/ \
			   debian/numba-doc/usr/share/doc/numba-doc/html/
endif

override_dh_python3:
	dh_python3
	dh_numpy3

override_dh_compress:
	dh_compress -X.ipynb -X.ods -X.py # save examples and notebooks

=== debian/tests/control ===
Tests: python3-numba
Depends: python3-numba,
 python3-cffi,
 python3-ipykernel,
 python3-ipython,
 python3-pip,
 python3-pexpect,
 gdb,
 gcc | c-compiler

## numba 0.59.1+dfsg

=== debian/changelog ===
numba (0.59.1+dfsg-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Diane Trout <diane@ghic.org>  Tue, 23 Apr 2024 19:36:40 -0700

numba (0.59.0+dfsg-3) unstable; urgency=medium

  * Override lintian binary warnings
    - shared-library-lacks-prerequisites for _devicearray.so
      as it's a simple static library
    - package-contains-documentation-outside-usr-share-doc
      numba/core/annotations/template.html is pretty print formatting
  * Attempt testing against Python 3.12

 -- Diane Trout <diane@ghic.org>  Fri, 22 Mar 2024 13:06:44 -0700

numba (0.59.0+dfsg-2) unstable; urgency=medium

  * Update numpy build-depends version to numba's current minimum
    (Closes: #1067504)

 -- Diane Trout <diane@ghic.org>  Fri, 22 Mar 2024 09:32:42 -0700

numba (0.59.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update minimum python3-llvmlite version to >= 0.42
  * Refresh patches
  * Try testing against python 3.12
  * Use numba's test random sampling in the autopkgtests.  This should
    allow the autopkgtests to pass.
  * Temporarily disable patches that my be resolved
    llvm_long_name_patch_PR4373, skip-unicode-buserror-armhf, armel-libatomic,
  * Permanently remove patches that no longer apply
    - python312-pr9246 (applied upstream)
    - remove-versioneer (no longer needed)
  * Add commented out pytest based test runner and test dependencies. It's
    faster than upstreams runner and looks to be better at time outs, but
    lacks the ability to do subsets of tests.

 -- Diane Trout <diane@ghic.org>  Thu, 14 Mar 2024 19:44:26 -0700

numba (0.58.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Include upstream WIP 9246 python 3.12 compatibility pull request as
    python312-pr9246.patch (Closes: #1057461)
  * Fix running autopackage tests. (Closes: #1043545)
  * Disable running subprocess tests to avoid a few python 3.11 test
    failures.
  * Remove copyrights for removed files
  * Update path to now .cpp file _hashlib.cpp in d/copyright
  * Add some descriptions to d/patches
  * Cleanup patches to use local sphinx indexes.
    - Removed duplicate patch file ignore-unavaiable-intersphinx.patch
    - Moved use-local-intersphinx.patch to earlier in the series
    - linked to python3-doc and llvmlite-doc files
    - Added llvmlite-doc to build-depends
  * Update Standards-Version to 4.6.2. No changes needed.
  * Re-enable building with libtbb
  * Remove source/lintian-overrides, upstream fixed the long line.
  * Disable running build tests against python3.12 for now.
    Remove when 0.59 is relelased
  * Use pattern for library-not-linked-against-libc override in
    python3-numba.lintian-overrides
  * lintian-override _dynfunc.cpython-*.so for not calling C functions as
    it just calls python functions.
  * lintian-override dudadrv/_extras, as CUDA is non-free and not available.
  * Remove embedded versioneer.py (Closes: #869538)
    - Add remove-versioneer.patch to remove now
    - Add versioneer.py to d/copyright Files-Excluded to remove in the
      future

 -- Diane Trout <diane@ghic.org>  Sun, 31 Dec 2023 14:19:49 -0800

numba (0.57.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Update no-git-in-generate_lower_listing.patch for changed version key
  * Configure intersphinx where available.
    - Add python-doc as a build dependency
    - Add ignore-unavailable-intersphinx.patch to point at local
      object.inv files
  * Add python3-setuptools to d/tests/control for a test dependency
  * Remove a bunch of backported patches needed for Python 3.11 compatibility
  * Refresh patches
  * Skip 3 tests that fail on autopkgtests. They should be investigated though

 -- Diane Trout <diane@ghic.org>  Tue, 30 May 2023 20:18:14 -0700

numba (0.56.4+dfsg-3) unstable; urgency=medium

  * Add armel-libatomic.patch for __sync_fetch_and_add_4 symbol
    (Closes: #994294)
    - Thanks to Michael Crusoe for the suggestion.
  * add use-local-intersphinx.patch to network access during doc build

 -- Diane Trout <diane@ghic.org>  Tue, 14 Feb 2023 09:24:19 -0800

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,11 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-python,
+               llvmlite-doc <!nodoc>,
                python3-all-dev,
                python3-colorama (>= 0.3.9~),
-               python3-llvmlite (>= 0.39~),
-               python3-numpy (<< 1:1.25),
+               python3-llvmlite (>= 0.42~),
+               python3-numpy (>= 1:1.22),
                python3-pip,
                sphinx,
                dh-sequence-sphinxdoc,
@@ -16,8 +17,10 @@
                python3-sphinx-rtd-theme,
                python3-setuptools,
                python3-numpydoc,
+               python3-doc <!nodoc>,
+               python3-versioneer,
                libtbb-dev (>= 2021.4.0)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/numba
 Vcs-Git: https://salsa.debian.org/science-team/numba.git
 Homepage: https://numba.pydata.org/

=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,6 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export PYBUILD_NAME            = numba
 export PYBUILD_INSTALL_ARGS    = --install-scripts=/usr/share/{package}
-
-# Disable TBB as Numba only supports up 2022.05.
-# https://github.com/numba/numba/issues/8487
-export NUMBA_DISABLE_TBB=1
 
 SPHINX_BUILD = $(shell py3versions -d) /usr/bin/sphinx-build
 PYBUILD_DEFAULT_VERSION = $(shell py3versions -v -d)

=== debian/tests/control ===
Tests: python3-numba
Depends: python3-numba,
 python3-all-dev,
 python3-cffi,
 python3-ipykernel,
 python3-ipython,
 python3-pip,
 python3-pexpect,
 python3-setuptools,
 python3-pytest,
 python3-pytest-xdist,
 python3-pytest-timeout,
 gdb,
 gcc | c-compiler

## numba 0.61.2+dfsg

=== debian/changelog ===
numba (0.61.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Backport NumPy 2.3 support (Closes: #1114705)

 -- Timo Röhling <roehling@debian.org>  Sat, 27 Sep 2025 12:33:17 +0200

numba (0.61.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove numpy-2.2-support.patch
  * Refresh patches

 -- Diane Trout <diane@ghic.org>  Sun, 13 Apr 2025 11:54:29 -0700

numba (0.61.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Update Build-Depends versions
    - llvmlite >= 0.44
    - numpy >= 1:2.2
  * added numpy-2.2-support.patch from upstream
    https://github.com/numba/numba/commit/1e2fb1d1c81880a645345991eb48e39b578e119d.patch
  * Added llvm-19-pr10011.patch
    https://github.com/numba/numba/pull/10011
  * Use python3-numba-dev as build-depend for dh_numpy3 command
  * Be very explicit that we want the numba script to be python3
    - somehow it was getting a python2 shebang header

 -- Diane Trout <diane@ghic.org>  Sun, 13 Apr 2025 10:04:11 -0700

numba (0.59.1+dfsg-3) unstable; urgency=medium

  * In Autopkgtests always cap the number of cores at 16.  We're having
    random failures on amd64 which has a high core count on the CI,
    upstream's comment implies they encountered that on ppc64.

 -- Diane Trout <diane@ghic.org>  Tue, 23 Jul 2024 11:42:33 -0700

numba (0.59.1+dfsg-2) unstable; urgency=medium

  * Remove || true and allow build time tests to fail again
  * Ran wrap-and-sort
  * Build-depend on architecture-is-64-bit.

 -- Diane Trout <diane@ghic.org>  Wed, 03 Jul 2024 10:50:50 -0700

numba (0.59.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Diane Trout <diane@ghic.org>  Tue, 23 Apr 2024 19:36:40 -0700

=== debian/control ===
--- 
+++ 
@@ -3,23 +3,24 @@
 Uploaders: Diane Trout <diane@ghic.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: architecture-is-64-bit,
+               debhelper-compat (= 13),
                dh-python,
+               dh-sequence-sphinxdoc,
+               libtbb-dev (>= 2021.4.0),
                llvmlite-doc <!nodoc>,
                python3-all-dev,
                python3-colorama (>= 0.3.9~),
-               python3-llvmlite (>= 0.42~),
-               python3-numpy (>= 1:1.22),
+               python3-doc <!nodoc>,
+               python3-llvmlite (>= 0.44~),
+               python3-numpy-dev (>= 1:2.2),
+               python3-numpydoc,
                python3-pip,
-               sphinx,
-               dh-sequence-sphinxdoc,
                python3-scipy,
+               python3-setuptools,
                python3-sphinx-rtd-theme,
-               python3-setuptools,
-               python3-numpydoc,
-               python3-doc <!nodoc>,
                python3-versioneer,
-               libtbb-dev (>= 2021.4.0)
+               sphinx
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/numba
 Vcs-Git: https://salsa.debian.org/science-team/numba.git
@@ -34,8 +35,7 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: numba-doc,
-            python3-pip
+Recommends: numba-doc, python3-pip
 Suggests: nvidia-cuda-toolkit [amd64 ppc64el]
 Description: native machine code compiler for Python 3
  Numba compiles native machine code instructions from Python programs at
@@ -52,8 +52,7 @@
 Package: numba-doc
 Architecture: all
 Section: doc
-Depends: ${sphinxdoc:Depends},
-         ${misc:Depends}
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Recommends: python3-numba
 Description: native machine code compiler for Python (docs)
  Numba compiles native machine code instructions from Python programs at

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 override_dh_auto_test-arch:
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 	PYBUILD_SYSTEM=custom \
-	PYBUILD_TEST_ARGS="ls {build_dir} && cd {build_dir} && MPLBACKEND=Agg {interpreter} -Wd runtests.py --exclude-tags='long-running,gdb,compiled_caching' -v -m --random 0.2 -- numba.tests"  dh_auto_test || true
+	PYBUILD_TEST_ARGS="ls {build_dir} && cd {build_dir} && MPLBACKEND=Agg {interpreter} -Wd runtests.py --exclude-tags='long-running,gdb,compiled_caching' -v -m --random 0.2 -- numba.tests"  dh_auto_test
 endif
 
 override_dh_installchangelogs:
@@ -35,7 +35,7 @@
 endif
 
 override_dh_python3:
-	dh_python3
+	dh_python3 --shebang=/usr/bin/python3
 	dh_numpy3
 
 override_dh_compress:

=== debian/tests/control ===
Tests: python3-numba
Depends: gcc | c-compiler,
         gdb,
         python3-all-dev,
         python3-cffi,
         python3-ipykernel,
         python3-ipython,
         python3-numba,
         python3-pexpect,
         python3-pip,
         python3-pytest,
         python3-pytest-timeout,
         python3-pytest-xdist,
         python3-setuptools

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*\/)?v?(\d[\d\.]+)\.tar\.gz/numba-$1.tar.gz/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg\d*$//,repack" \
https://github.com/numba/numba/tags (?:.*/)?v?(\d[\d\.]+)\.tar\.gz

## numba 0.63.1+dfsg

=== debian/changelog ===
numba (0.63.1+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - Adds Python 3.14 support (Closes: #1119030, #1123334)
    - update versioned build-dependency on llvmlite
    - refresh patches
  * Suppress tests that write files in readonly installation
    (test_default_locators, test_source_stamp_precision).
  * Update Standards-Version to 4.7.3 (no changes required).
  * Drop unneeded Priority:optional and R3:no fields.
  * Update lintian overrides.

 -- Stuart Prescott <stuart@debian.org>  Thu, 05 Feb 2026 13:57:06 +1100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Diane Trout <diane@ghic.org>
 Section: science
-Priority: optional
 Build-Depends: architecture-is-64-bit,
                debhelper-compat (= 13),
                dh-python,
@@ -12,7 +11,7 @@
                python3-all-dev,
                python3-colorama (>= 0.3.9~),
                python3-doc <!nodoc>,
-               python3-llvmlite (>= 0.44~),
+               python3-llvmlite (>= 0.46~),
                python3-numpy-dev (>= 1:2.2),
                python3-numpydoc,
                python3-pip,
@@ -21,11 +20,10 @@
                python3-sphinx-rtd-theme,
                python3-versioneer,
                sphinx
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/science-team/numba
 Vcs-Git: https://salsa.debian.org/science-team/numba.git
 Homepage: https://numba.pydata.org/
-Rules-Requires-Root: no
 
 Package: python3-numba
 Architecture: any

## numba cuda-0.0.18

=== numba_cuda/numba/cuda/tests/test_binary_generation/Makefile ===
# Generates the input files used by the pynvjitlink binding test suite

# Test binaries are built taking into account the CC of the GPU in the test machine
GPU_CC := $(shell nvidia-smi --query-gpu=compute_cap --format=csv | grep -v compute_cap | head -n 1 | sed 's/\.//')
GPU_CC ?= 75

# Use CC 7.0 as an alternative in fatbin testing, unless CC is 7.x
ifeq ($(shell echo "$(GPU_CC)" | cut -c1),7)
    ALT_CC := 80
else
    ALT_CC := 70
endif

# Gencode flags suitable for most tests
GENCODE := -gencode arch=compute_$(GPU_CC),code=sm_$(GPU_CC)

# Fatbin tests need to generate code for an additional compute capability
FATBIN_GENCODE := $(GENCODE) -gencode arch=compute_$(ALT_CC),code=sm_$(ALT_CC)

# LTO-IR tests need to generate for the LTO "architecture" instead
LTOIR_GENCODE := -gencode arch=lto_$(GPU_CC),code=lto_$(GPU_CC)

# Compile with optimization; use relocatable device code to preserve device
# functions in the final output
NVCC_FLAGS := -O3 -rdc true

# Flags specific to output type
CUBIN_FLAGS := $(GENCODE) --cubin
PTX_FLAGS := $(GENCODE) -ptx
OBJECT_FLAGS := $(GENCODE) -dc
LIBRARY_FLAGS := $(GENCODE) -lib
FATBIN_FLAGS := $(FATBIN_GENCODE) --fatbin
LTOIR_FLAGS := $(LTOIR_GENCODE) -dc

OUTPUT_DIR := ./

all:
	@echo "GPU CC: $(GPU_CC)"
	@echo "Alternative CC: $(ALT_CC)"
	# Compile all test objects
	nvcc $(NVCC_FLAGS) $(CUBIN_FLAGS) -o $(OUTPUT_DIR)/undefined_extern.cubin undefined_extern.cu
	nvcc $(NVCC_FLAGS) $(CUBIN_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.cubin test_device_functions.cu
	nvcc $(NVCC_FLAGS) $(FATBIN_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.fatbin test_device_functions.cu
	nvcc $(NVCC_FLAGS) $(PTX_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.ptx test_device_functions.cu
	nvcc $(NVCC_FLAGS) $(OBJECT_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.o test_device_functions.cu
	nvcc $(NVCC_FLAGS) $(LIBRARY_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.a test_device_functions.cu

	# Generate LTO-IR wrapped in a fatbin
	nvcc $(NVCC_FLAGS) $(LTOIR_FLAGS) -o $(OUTPUT_DIR)/test_device_functions.ltoir.o test_device_functions.cu
	# Generate LTO-IR in a "raw" LTO-IR container
	python generate_raw_ltoir.py --arch sm_$(GPU_CC) -o $(OUTPUT_DIR)/test_device_functions.ltoir test_device_functions.cu
